/*typedef struct Lock{
  char on_seconds, on_minutes, on_hours;
  char off_seconds, off_minutes, off_hours;
  char modified;
} TLock;

extern TLock Locks[4]; // we will use 4 relays/locks
extern char index;
extern char kp, ShowTime, SetupTime, noChange;
extern char index, CurrentLock;
extern char seconds, old_seconds, minutes, hours, day, month, year;

void Set_Time(char hour, char minute);*/

#include "unglobals.h"

// Perform action depending on which key is pressed
static void ProcessKey(char Key){
  switch(index){ // index tells us which digit is being modified
    case 0: 
      if (Key < 3){ // hours can't go over 24, allow digits from 0..3
          Locks[CurrentLock].on_hours = Key * 10 + Locks[CurrentLock].on_hours % 10;
          Locks[CurrentLock].modified = 1;
          index++; // move right
        }
        break;
    case 1: 
      if (Locks[CurrentLock].on_hours < 20){ // allow digits from 0..9
           if (Key < 10){
               Locks[CurrentLock].on_hours = 10*(Locks[CurrentLock].on_hours / 10) + Key;
               Locks[CurrentLock].modified = 1;
               index++; // move right
            }
       else if (Locks[CurrentLock].on_hours < 24){ // hours can't go over 24, , allow digits from 0..3
           if (Key < 4){
               Locks[CurrentLock].on_hours = 10*(Locks[CurrentLock].on_hours / 10) + Key;
               Locks[CurrentLock].modified = 1;
               index++; // move right
             }
         }
      }
      break;
    case 2: if (Key < 6) { // minutes can go over 59, allow digits 0..5
           Locks[CurrentLock].on_minutes = Key * 10 + Locks[CurrentLock].on_minutes % 10;
           Locks[CurrentLock].modified = 1;
           index++; // move right
         }
         break;
    case 3: if (Key < 10){
           Locks[CurrentLock].on_minutes = 10*(Locks[CurrentLock].on_minutes / 10) + Key;
           Locks[CurrentLock].modified = 1;
           index++; // move right
         }
         break;
    case 4: if (Key < 6){ // seconds can go over 59, allow digits 0..5
           Locks[CurrentLock].on_seconds = Key * 10 + Locks[CurrentLock].on_seconds % 10;
           Locks[CurrentLock].modified = 1;
           index++; // move right
         }
         break;
    case 5: if (Key < 10){
           Locks[CurrentLock].on_seconds = 10*(Locks[CurrentLock].on_seconds / 10) + Key;
           Locks[CurrentLock].modified = 1;
           index++; // move right
         }
         break;
         
    //------ OFF TIME or SETUP TIME ------
    case 6: 
        if (Key < 3){  // hours can't go over 24, allow digits from 0..3
          if (SetupTime){
              hours = Key * 10 + hours % 10;
              noChange = 0; // force refresh
            }
          else
            {
              Locks[CurrentLock].off_hours = Key * 10 + Locks[CurrentLock].off_hours % 10;
              Locks[CurrentLock].modified = 1;
            }
          ++index; // move right
        }
        break;
    case 7: 
         if (SetupTime){ // setting clock
           if (hours < 20){
               if (Key < 10){
                   hours = 10*(hours / 10) + Key;
                   ++index; // move right
                   noChange = 0; // force refresh
                }
             }
           else // hours can't go over 24, allow digits from 0..3
             {
               if (Key < 4){
                   hours = 10*(hours / 10) + Key;
                   ++index; // move right
                   noChange = 0; // force refresh
                 }
             }
         }
       else // off time
         {
           if (Locks[CurrentLock].off_hours < 20){
               if (Key < 10){
                   Locks[CurrentLock].off_hours = 10*(Locks[CurrentLock].off_hours / 10) + Key;
                   Locks[CurrentLock].modified = 1;
                   ++index; // move right
                }
             }
           else if (Locks[CurrentLock].off_hours < 24){ // hours can't go over 24, allow digits from 0..3
               if (Key < 4){
                 {
                   Locks[CurrentLock].off_hours = 10*(Locks[CurrentLock].off_hours / 10) + Key;
                   Locks[CurrentLock].modified = 1;
                   ++index; // move right
                 }
             }
           }
         }
      break;
    case 8: 
         if (Key < 6){ // minutes can't go over 59, allow digits from 0..5
           if (SetupTime){
               minutes = Key * 10 + minutes % 10;
               noChange = 0; // force refresh
             }
           else
             {
               Locks[CurrentLock].off_minutes = Key * 10 + Locks[CurrentLock].off_minutes % 10;
               Locks[CurrentLock].modified = 1;
             }
           ++index; // move right
         }
         break;
    case 9:
         if (Key < 10){
           if (SetupTime){
               minutes = 10*(minutes / 10) + Key;
               noChange = 0; // force refresh
               index = 6; // move to first digit of hours
             }
           else
             {
               Locks[CurrentLock].off_minutes = 10*(Locks[CurrentLock].off_minutes / 10) + Key;
               Locks[CurrentLock].modified = 1;
               ++index; // move right
             }
         }
         break;
    case 10: 
         if (Key < 6){ // seconds can't go over 59, allow digits from 0..5
           if (SetupTime){
              // can't set seconds at the moment
               //seconds = Key * 10 + seconds mod 10;
             }
           else
             {
               Locks[CurrentLock].off_seconds = Key * 10 + Locks[CurrentLock].off_seconds % 10;
               Locks[CurrentLock].modified = 1;
             }
           ++index; // move right
         }
         break;
    case 11: 
         if (Key < 10){ // allow digits 0..9
           if (SetupTime){
               //can't set seconds at the moment
               //seconds = 10*(seconds div 10) + Key;
               //index = 0;
             }
           else
             {
               Locks[CurrentLock].off_seconds = 10*(Locks[CurrentLock].off_seconds / 10) + Key;
               Locks[CurrentLock].modified = 1;
               index = 0;
             }
         }
         break;
  }
}

void ProcessCommand(char comm){
  switch (comm){  // command is being issued
    case 35: 
        { // move cursor right
          if (SetupTime){
              if (index < 9) index++;
              else index = 6;
              noChange = 0;   // force redraw
            }
          else
            {
              if (index < 11) index++;
              else index = 0;
              Locks[CurrentLock].modified = 1; // force redraw
            }
        }
       break;
    case 42: 
       {  // move cursor left
          if (SetupTime){
              if (index > 6) index--;
              else index = 9;
              noChange = 0;   // force redraw
            }
          else
            {
              if (index > 0) index--;
              else index = 11;             // the last digit in second row
              Locks[CurrentLock].modified = 1; // force redraw
            }
        }
       break;
   case 66:
        { // B - Setup time
          SetupTime = !SetupTime;
          if (SetupTime){
              Lcd_Cmd(_LCD_CLEAR);
              Lcd_Cmd(_LCD_BLINK_CURSOR_ON);
              index = 6;   // first hours digit
              seconds = 0; // can't set seconds at the moment
              noChange = 0; // force refresh
            }
          else
            {
              // write new time
              Lcd_Cmd(_LCD_CURSOR_OFF); // no cursor when time is shown
              Set_Time(hours, minutes); // set new time
            }
          ShowTime = 1;
          Lcd_Chr(2,  9, ':');
          Lcd_Chr(2, 12, ':');
          Lcd_Out(1, 1, "Current time");
        }
      break;
    case 67:
        if (!SetupTime) //  do nothing if in setup
        { // C - Show / Hide clock
          ShowTime = ! ShowTime;
          Lcd_Cmd(_LCD_CLEAR);        // Clear LCD display
          if (showTime){
               Lcd_Cmd(_LCD_CURSOR_OFF); // no cursor when time is shown
               Lcd_Chr(2,  9, ':');
               Lcd_Chr(2, 12, ':');
               Lcd_Out(1, 1, "Current time");
            }
          else
            {
              Lcd_Cmd(_LCD_BLINK_CURSOR_ON); // cursor blinks on setup screen
            }
        }
      break;
    case 68: 
      { // D - next lock
          if (!ShowTime){  // change setup screen only when time is not shown
              index = 0;
              ++CurrentLock; // move to next lock
              if (CurrentLock >= 4)
                CurrentLock = 0;
              Locks[CurrentLock].modified = 1; // force redraw
            }
       }
     break;
  } // case
}

void ReadKeypad(){  // read keypad
 kp = Keypad_Key_Click(); // Store key code in kp variable
 if (!kp==0){
      switch (kp){           // map the keys
        case 1: kp = 1;break;   // 1
        case 2: kp = 2;break;   // 2
        case 3: kp = 3;break;   // 3
        case 4: kp = 65;break;  // A
        case 5: kp = 4;break;   // 4
        case 6: kp = 5;break;   // 5
        case 7: kp = 6;break;   // 6
        case 8: kp = 66;break;  // B  setup time
        case 9: kp = 7;break;   // 7
        case 10: kp = 8;break;   // 8
        case 11: kp = 9;break;   // 9
        case 12: kp = 67;break;  // C  show current time
        case 13: kp = 42;break;  // *  cursor left
        case 14: kp = 0;break;   // 0
        case 15: kp = 35;break;  // #  cursor right
        case 16: kp = 68;break;  // D  next lock
      }
      if (kp < 10)  // if digits 0..9
        ProcessKey(kp);
      else             // a command is issued
        ProcessCommand(kp);
   }
}