#include "unglobals.h"

void MoveCursor(){
char i, moveto;
   if (index < 6)
     Lcd_Cmd(_LCD_FIRST_ROW);
   else
     Lcd_Cmd(_LCD_SECOND_ROW);

   moveto = 6;
   switch (index){   // calculate where to put the cursor
     case 0:
     case 6: moveto =  6; break;
     case 1:
     case 7: moveto =  7; break;
     case 2:
     case 8: moveto =  9; break;
     case 3:
     case 9: moveto = 10; break;
     case 4:
     case 10: moveto = 12; break;
     case 5:
     case 11: moveto = 13; break;
   }; // case

   for (i = 1; i <= moveto; i++)   // move the cursor
      lcd_cmd(_LCD_MOVE_CURSOR_RIGHT);
}

// Display current time on LCD
void Display_Time(){
   if (SetupTime)
     if (noChange)  // do not refresh if not needed, avoid flicker
       return;
   Lcd_Chr(2,  7, (hours / 10)      + 48);
   Lcd_Chr(2,  8, (hours % 10)      + 48);
   Lcd_Chr(2, 10, (minutes / 10)    + 48);
   Lcd_Chr(2, 11, (minutes % 10)    + 48);
   Lcd_Chr(2, 13, (seconds / 10)    + 48);
   Lcd_Chr(2, 14, (seconds % 10)    + 48);
   if (SetupTime) // if in setup then show cursor
     {
       MoveCursor(); // move blinking cursor to active digit
       noChange = 1; // mark that the change has been drawn on LCD
     }
}

// Display setup screns
void Display_Alarm_Time(){
//    index:   01 23 45
//    RxOn     00:00:00
//    RxOff    00:00:00
//    index:   67 89 AB

   Lcd_Chr(2,  9, ':');
   Lcd_Chr(2, 12, ':');
   Lcd_Chr(1,  9, ':');
   Lcd_Chr(1, 12, ':');

   Lcd_Chr(1,  1, 'R');
   Lcd_Chr(1,  2, CurrentLock + 48 + 1);
   Lcd_Chr(1,  3, 'O');
   Lcd_Chr(1,  4, 'N');
   Lcd_Chr(1,  7, (Locks[CurrentLock].on_hours / 10)     + 48);
   Lcd_Chr(1,  8, (Locks[CurrentLock].on_hours % 10)   + 48);
   Lcd_Chr(1, 10, (Locks[CurrentLock].on_minutes / 10)   + 48);
   Lcd_Chr(1, 11, (Locks[CurrentLock].on_minutes % 10) + 48);
   Lcd_Chr(1, 13, (Locks[CurrentLock].on_seconds / 10)   + 48);
   Lcd_Chr(1, 14, (Locks[CurrentLock].on_seconds % 10) + 48);

   Lcd_Chr(2,  1, 'R');
   Lcd_Chr(2,  2, CurrentLock + 48 + 1);
   Lcd_Chr(2,  3, 'O');
   Lcd_Chr(2,  4, 'F');
   Lcd_Chr(2,  5, 'F');
   Lcd_Chr(2,  7, (Locks[CurrentLock].off_hours / 10)    + 48);
   Lcd_Chr(2,  8, (Locks[CurrentLock].off_hours % 10)  + 48);
   Lcd_Chr(2, 10, (Locks[CurrentLock].off_minutes / 10)  + 48);
   Lcd_Chr(2, 11, (Locks[CurrentLock].off_minutes % 10)+ 48);
   Lcd_Chr(2, 13, (Locks[CurrentLock].off_seconds / 10)  + 48);
   Lcd_Chr(2, 14, (Locks[CurrentLock].off_seconds % 10)+ 48);

   MoveCursor();

   Locks[CurrentLock].modified = 0;  // Mark current screen processed
}
